package ch.il07.converter.business;

public class ServiceFactoryAdapter {
	
	/**
	 * Gets an instance of user.
	 * @return An instance of user
	 */
	public static UserBusiness getUserBusinessInstance() {
		try {
			return (UserBusiness) ServiceFactory.getInstance(UserBusiness.class);
		} catch (Exception e) {
			return null;
		}
	}
	
	/**
	 * Gets an instance of converter.
	 * @return An instance of converter
	 */
	public static Converter getConverterInstance() {
		try {
			return (Converter) ServiceFactory.getInstance(Converter.class);
		} catch (Exception e) {
			return null;
		}
	}
	
	/**
	 * Gets an instance of measurandaction
	 * @return An instance of measurandaction
	 */
	public static MeasurandAction getMeasurandActionInstance() {
		try {
			return (MeasurandAction) ServiceFactory.getInstance(MeasurandAction.class);
		} catch (Exception e) {
			return null;
		}
	}
	
	/**
	 * Gets an instance of unitaction
	 * @return An instance of unitaction
	 */
	public static UnitAction getUnitActionInstance() {
		try {
			return (UnitAction) ServiceFactory.getInstance(UnitAction.class);
		} catch (Exception e) {
			return null;
		}
	}
}
